<?php

/**
 * @file
 * Contains \Drupal\drd\Plugin\Action\ProjectsUpdate.
 */

namespace Drupal\drd\Plugin\Action;

use Drupal\Core\Annotation\Action;
use Drupal\Core\Annotation\Translation;

/**
 * Provides a 'ProjectsUpdate' action.
 *
 * @Action(
 *  id = "drd_action_projects_update",
 *  label = @Translation("Update Projects"),
 *  type = "drd_core",
 * )
 */
class ProjectsUpdate extends BaseCoreRemote {

  /**
   * @inheritdoc
   */
  public function executeAction($core) {
    $plugin = $core->getUpdatePlugin();
    if (empty($plugin)) {
      return FALSE;
    }

    $releases = $core->getAvailableUpdates();
    if (!empty($releases)) {
      $plugin->execute($releases);
    }

    return TRUE;
  }

}
