<?php

namespace Drupal\drd\Plugin\Update;

use Drupal\Core\Form\FormStateInterface;
use Psy\Util\Json;

/**
 * Provides a abstract class for composer based update plugins.
 */
abstract class Composer extends Base {

  /**
   * @inheritDoc
   */
  public function defaultConfiguration() {
    return [] + parent::defaultConfiguration();
  }

  /**
   * @inheritDoc
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $element = parent::buildConfigurationForm($form, $form_state);

    return $element;
  }

  /**
   * @inheritDoc
   */
  public function validateConfigurationForm(array &$form, FormStateInterface $form_state) {
    parent::validateConfigurationForm($form, $form_state);
  }

  /**
   * @inheritDoc
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    parent::submitConfigurationForm($form, $form_state);
  }

  /**
   * @inheritDoc
   */
  public function updateWorkingDirectory($releases) {
    $composer_filename = $this->workingDirectory . DIRECTORY_SEPARATOR . 'composer.json';
    $composer = \Drupal\Component\Serialization\Json::decode(file_get_contents($composer_filename));

    foreach ($releases as $release) {
      $name = ($release->getProjectType() == 'core') ?
        'core' :
        $release->getMajor()->getProject()->getName();
      $composer['require']['drupal/' . $name] = $release->getVersion();
    }

    file_put_contents($composer_filename, Json::encode($composer, JSON_PRETTY_PRINT));
    return $this;
  }

}
