<?php

namespace Drupal\drd;

use Drupal\Component\Plugin\PluginManagerInterface;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides an interface for the discovery and instantiation of DRD Update plugins.
 */
interface UpdateManagerInterface extends PluginManagerInterface {

  /**
   * A form API container with all the settings for DRD Update plugins.
   *
   * @param array $form
   * @param FormStateInterface $form_state
   * @param array $settings
   */
  public function buildGlobalForm(&$form, $form_state, $settings);

  /**
   * @param array $form
   * @param FormStateInterface $form_state
   * @param string $key
   */
  public function validateGlobalForm(&$form, $form_state, $key);

  /**
   * @param array $form
   * @param FormStateInterface $form_state
   * @param string $key
   * @return array
   */
  public function globalFormValues($form, $form_state, $key);

}
